#apcupsd monditor through apcaccess
# Author: John A. Mason
#Note: this is quick and dirty. feel free to change as you wish

package Requester::apcupsd;

use strict;

@Requester::apcupsd::ISA = qw(Requester::Requester);

my $requester = new Requester::apcupsd;

sub new
{
    my ($this, $args ) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);
    $self->register( "apcupsd" );
    return $self;
}

sub getinfo {
    my( $self ) = @_;
    my( $host ) = $self->{"env"}->{"nodeinstance"}->{"host"};
    my( $port ) = 3551;
    my( $command ) = "apcaccess status $host $port 2>/dev/null|";

    my( $linev ) = 0;
    my( $loadpct ) = 0;
    my( $bcharge ) = 0;
    my( $timeleft ) = 0;
    my( $outputv ) = 0;
    my( $lotrans ) = 0;
    my( $hitrans ) = 0;
    my( $itemp ) = 0;
    my( $battv ) = 0;
    my( $linefreq ) = 0;

    open( APCACCESS, $command );
    while( <APCACCESS> ) {
        #chomp;

	if (m/^LINEV\s*: /) {
		$linev = $_;
		$linev =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^LOADPCT\s*: /) {
		$loadpct = $_;
		$loadpct =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^BCHARGE\s*: /) {
		$bcharge = $_;
		$bcharge =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^TIMELEFT\s*: /) {
		$timeleft = $_;
		$timeleft =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^OUTPUTV\s*: /) {
		$outputv = $_;
		$outputv =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^LOTRANS\s*: /) {
		$lotrans = $_;
		$lotrans =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^HITRANS\s*: /) {
		$hitrans = $_;
		$hitrans =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^ITEMP\s*: /) {
		$itemp = $_;
		$itemp =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^BATTV\s*: /) {
		$battv = $_;
		$battv =~ s/[^0-9.-]//g;
		next;
	}

	if (m/^LINEFREQ\s*: /) {
		$linefreq = $_;
		$linefreq =~ s/[^0-9.-]//g;
		next;
	}
    }
    close APCACCESS;
    return( {} ) if( $? );

    print "apcupsd: values read from $host:\n\tLINEV   : $linev Volts\n\tLOADPCT : $loadpct % Load Capacity\n\tBCHARGE : $bcharge %\n\tTIMELEFT: $timeleft Min\n\tOUTPUTV : $outputv Volts\n";
    print "\tLOTRANS : $lotrans Volts\n\tHITRANS : $hitrans Volts\n\tITEMP   : $itemp C Internal\n\tBATTV   : $battv Volts\n\tLINEFREQ: $linefreq Hz\n";

    return { 0 => {
	"linev" => $linev,
	"loadpct" => $loadpct,
        "bcharge" => $bcharge,
        "timeleft" => $timeleft,
	"outputv" => $outputv,
	"lotrans" => $lotrans,
	"hitrans" => $hitrans,
        "itemp" => $itemp,
	"battv" => $battv,
        "linefreq" => $linefreq
	
    } };
}


1;

